<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSetDati ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSetDati
 * @subpackage Arrays
 */
class ArrayOfSetDati extends AbstractStructArrayBase
{
    /**
     * The SetDati
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SetDati[]
     */
    public $SetDati;
    /**
     * Constructor method for ArrayOfSetDati
     * @uses ArrayOfSetDati::setSetDati()
     * @param \StructType\SetDati[] $setDati
     */
    public function __construct(array $setDati = array())
    {
        $this
            ->setSetDati($setDati);
    }
    /**
     * Get SetDati value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SetDati[]|null
     */
    public function getSetDati()
    {
        return isset($this->SetDati) ? $this->SetDati : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSetDati method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSetDati method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSetDatiForArrayConstraintsFromSetSetDati(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSetDatiSetDatiItem) {
            // validation for constraint: itemType
            if (!$arrayOfSetDatiSetDatiItem instanceof \StructType\SetDati) {
                $invalidValues[] = is_object($arrayOfSetDatiSetDatiItem) ? get_class($arrayOfSetDatiSetDatiItem) : sprintf('%s(%s)', gettype($arrayOfSetDatiSetDatiItem), var_export($arrayOfSetDatiSetDatiItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SetDati property can only contain items of type \StructType\SetDati, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SetDati value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SetDati[] $setDati
     * @return \ArrayType\ArrayOfSetDati
     */
    public function setSetDati(array $setDati = array())
    {
        // validation for constraint: array
        if ('' !== ($setDatiArrayErrorMessage = self::validateSetDatiForArrayConstraintsFromSetSetDati($setDati))) {
            throw new \InvalidArgumentException($setDatiArrayErrorMessage, __LINE__);
        }
        if (is_null($setDati) || (is_array($setDati) && empty($setDati))) {
            unset($this->SetDati);
        } else {
            $this->SetDati = $setDati;
        }
        return $this;
    }
    /**
     * Add item to SetDati value
     * @throws \InvalidArgumentException
     * @param \StructType\SetDati $item
     * @return \ArrayType\ArrayOfSetDati
     */
    public function addToSetDati(\StructType\SetDati $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SetDati) {
            throw new \InvalidArgumentException(sprintf('The SetDati property can only contain items of type \StructType\SetDati, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SetDati[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SetDati|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SetDati|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SetDati|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SetDati|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SetDati|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SetDati
     */
    public function getAttributeName()
    {
        return 'SetDati';
    }
}
