<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetEnabledDataSet_Output StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:GetEnabledDataSet_Output
 * @subpackage Structs
 */
class GetEnabledDataSet_Output extends AbstractStructBase
{
    /**
     * The CodEsito
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CodEsito;
    /**
     * The DescEsito
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DescEsito;
    /**
     * The SetDatiAbilitati
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfSetDati
     */
    public $SetDatiAbilitati;
    /**
     * Constructor method for GetEnabledDataSet_Output
     * @uses GetEnabledDataSet_Output::setCodEsito()
     * @uses GetEnabledDataSet_Output::setDescEsito()
     * @uses GetEnabledDataSet_Output::setSetDatiAbilitati()
     * @param string $codEsito
     * @param string $descEsito
     * @param \ArrayType\ArrayOfSetDati $setDatiAbilitati
     */
    public function __construct($codEsito = null, $descEsito = null, \ArrayType\ArrayOfSetDati $setDatiAbilitati = null)
    {
        $this
            ->setCodEsito($codEsito)
            ->setDescEsito($descEsito)
            ->setSetDatiAbilitati($setDatiAbilitati);
    }
    /**
     * Get CodEsito value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCodEsito()
    {
        return isset($this->CodEsito) ? $this->CodEsito : null;
    }
    /**
     * Set CodEsito value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $codEsito
     * @return \StructType\GetEnabledDataSet_Output
     */
    public function setCodEsito($codEsito = null)
    {
        // validation for constraint: string
        if (!is_null($codEsito) && !is_string($codEsito)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codEsito, true), gettype($codEsito)), __LINE__);
        }
        if (is_null($codEsito) || (is_array($codEsito) && empty($codEsito))) {
            unset($this->CodEsito);
        } else {
            $this->CodEsito = $codEsito;
        }
        return $this;
    }
    /**
     * Get DescEsito value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDescEsito()
    {
        return isset($this->DescEsito) ? $this->DescEsito : null;
    }
    /**
     * Set DescEsito value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $descEsito
     * @return \StructType\GetEnabledDataSet_Output
     */
    public function setDescEsito($descEsito = null)
    {
        // validation for constraint: string
        if (!is_null($descEsito) && !is_string($descEsito)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descEsito, true), gettype($descEsito)), __LINE__);
        }
        if (is_null($descEsito) || (is_array($descEsito) && empty($descEsito))) {
            unset($this->DescEsito);
        } else {
            $this->DescEsito = $descEsito;
        }
        return $this;
    }
    /**
     * Get SetDatiAbilitati value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfSetDati|null
     */
    public function getSetDatiAbilitati()
    {
        return isset($this->SetDatiAbilitati) ? $this->SetDatiAbilitati : null;
    }
    /**
     * Set SetDatiAbilitati value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfSetDati $setDatiAbilitati
     * @return \StructType\GetEnabledDataSet_Output
     */
    public function setSetDatiAbilitati(\ArrayType\ArrayOfSetDati $setDatiAbilitati = null)
    {
        if (is_null($setDatiAbilitati) || (is_array($setDatiAbilitati) && empty($setDatiAbilitati))) {
            unset($this->SetDatiAbilitati);
        } else {
            $this->SetDatiAbilitati = $setDatiAbilitati;
        }
        return $this;
    }
}
